#ifndef UTIL_H
#define UTIL_H

// util.h--Miscellaneous graphic and sprite-related utility functions for TI-89 and possibly 92+

// Yeah, I know that the extgraph library already does all this stuff and more,
// but for some strange reason I felt like I wanted to write it myself.  Got
// bits on the brain or something.

// (C) 2003-2005 Jeremy Stanley <jstanley0@gmail.com>
// This program is licensed under the GNU General Public License
// see COPYING for details

// Returns non-zero if the two rectangles intersect.  The arrays are for the top-left
// corner of the rect; then the other parameters are widths and heights.
int rects_overlap(short r1x[2], short w1, short h1, short r2x[2], short w2, short h2);		

// Eh.  Take a wild guess.               
void invert_lcd(void *buf);

// ORs in an eight-pixel-wide sprite of height h at (x, y)
void sprite8(short x, short y, short h, unsigned char *sp, void *scr);

// Same as sprite8, except it returns non-zero if a black pixel in the sprite intersects
// a black pixel already on the screen.  
int sprite8_draw_ctest(short x, short y, short h, unsigned char *sp, void *scr);

// center a string using the given font and attribute
void center_string(short row, short dx, const char *str, short font, short attr);

// fast vertical line function
void vline(short x, short y, short h, void *buf);

// fast horizontal line function (writes up to 16 pixels at a time)
void hline(short x, short y, short w, void *buf);

// draw a rectangle...
void draw_rect(short x, short y, short w, short h, void *buf);

// erase a rectangle...
void erase_rect(short x, short y, short w, short h, void *buf);

// fast pixel macros [ FYI: my own benchmarks show that (y * 30) is faster than
// (y << 5) - (y << 1), so don't ask me about that "optimization" ]

#define pixel_ptr(x, y, buf) (((unsigned char *)buf) + ((y) * 30) + ((x) >> 3))

#define pixel_mask(x) ((0x80 >> ((x) & 7)))

#define set_pixel(x, y, buf) (*pixel_ptr(x, y, buf) |= pixel_mask(x))

#endif
				                  
				                  
				                  
				                  